var importedPackages = ["keosu-base","angularJs","jQuery","keosu-push","keosu-menu","keosu-rss","keosu-article","keosu-comments"];

var pushNotificationData = { senderID : '207204950867'};
var app = angular.module('keosuApp', ['angularSpinner','angular-carousel','ngSanitize', 'ngTouch', 'ngRoute','angular-inview','LocalStorageModule','CacheManagerModule','ui.bootstrap']);

app.controller('main_Controller', function($http, $rootScope, $scope) {
	$http.get('data/globalParam.json').success(function(data) {

		$rootScope.appName = data.name;

		 // $rootScope;previousButton : used to display a return button in the header
		 // to show the button you should set the value true to the boolean
		 // when you click on the button, the method $rootScope.prev is called
		$rootScope.previousButton = false;
	});
	//alert("Connection :"+navigator.connection.type);
	$rootScope.offline = false;
	document.addEventListener("offline", function() {
		$rootScope.offline = true;
		alert("Network unreachable. The page will be reload soon as possible.");
		document.addEventListener("online", function() {
			$rootScope.offline = false;
			alert("Reconnection !");
			document.removeEventListener("online", function(){}, false);
			location.reload();
		}, false);
	}, false);

	$scope.alert = function(title, message) {
		if (typeof navigator.notification === 'undefined') {
			alert(message);
		} else {
			navigator.notification.alert(
				message,
				function(){},
				title,
				'OK'
			);
		}
	};
});

// Don't forget to take a look at exportListener.php before edit this file
app.directive('keosuPush', function(){
	return {
		restrict : 'E',
		templateUrl : 'plugins/keosu-push/templates/default.html',
		controller : ['$scope','$http', function ($scope, $http) {

			$http.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";

			$scope.init = function() {
				console.log('function init');
				document.addEventListener('deviceready', function() {
					console.log('i\'m ready');
					// if push notification is enabled
					pushNotification = window.plugins.pushNotification;
					if(typeof(device) != 'undefined' && typeof(pushNotificationData) != 'undefined') {
						$http.get('data/globalParam.json').success(function(data) {
							$scope.host = data.host;
							if(device.platform == 'android' || device.platform == 'Android' || device.platform == "amazon-fireos") {
								$scope.androidPush();
							} else {
								$scope.applePush();
							}
						});
					}
				},false);
			};

			////////////////////////
			// Android part
			////////////////////////
			$scope.androidPush = function() {
				appAndroid = {
					successHandler: function(result) {
						console.log("Push success : "+result);
					},
					errorHandler: function(error) {
						console.log("Push error : "+error);
					},
					onNotification: function(e) {
						switch( e.event ) {
							case 'registered':
							if ( e.regid.length > 0 ) {
								$http.post($scope.host+'service/push/plugin/addDevice/2','token='+e.regid);
							}
							break;

							case 'message':
							// this is the actual push notification. its format depends on the data model from the push server
							console.log('message = '+e.message+' msgcnt = '+e.msgcnt);
							break;

							case 'error':
							console.log('GCM error = '+e.msg);
							break;

							default:
							console.log('An unknown GCM event has occurred');
							break;
						}
					}
				};

				pushNotification.register(
					appAndroid.successHandler,
					appAndroid.errorHandler,
					{'senderID':pushNotificationData.senderID+"",'ecb': "appAndroid.onNotification" }
				);
			};
		
			/////////////////////
			// Apple part
			/////////////////////
			$scope.applePush = function() {
				console.log('I\'m an Iphone...');
				appPushNotification = {
					tokenHandler: function(result) {
						console.log('iphone id');
						console.log(result);
						if( result.length > 0 ) {
							$http.post($scope.host+'service/push/plugin/addDevice/1','token='+result);
						}
					},
					errorHandler: function(error){console.log('the eoor is '+error)},
					onNotificationAPN: function(event) {
						if( event.alert )
							navigator.notification.alert(event.alert);
						if( event.sound ) {
							var snd = new Media(event.sound);
							snd.play();
						}
						if( event.badge )
							pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, event.badge);
					}
				};

				pushNotification.register(
					appPushNotification.tokenHandler,
					appPushNotification.errorHandler,
					{
						'badge' : 'true',
						'sound' : 'true',
						'alert' : 'true',
						'ecb'   : 'appPushNotification.onNotificationAPN'
					}
				);
			};

		}]
	};
});


app.config(function($routeProvider,$locationProvider){
	$routeProvider.when("/Page/:pageName",{
		templateUrl: function(params) {
			return params.pageName+".html";
		}
	})
	.otherwise({redirectTo:"/Page/1"});
});/************************************************************************
	Keosu is an open source CMS for mobile app
	Copyright (C) 2013  Vincent Le Borgne

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ************************************************************************/
app.controller('keosu-menuController', function ($scope, $http,$location) {
	$scope.init = function(params) {
		$scope.pages = params.gadgetParam.pages;
		$http.get('data/'+params.gadgetId+".json").success(function(data) {
			$scope.pages = data;
		});
	};

    $scope.getPath = function(icon,iconActive, page) {

        return $location.path() == '/Page/'+page ? 'data/menu/'+iconActive : 'data/menu/'+icon;
    }

	// @see https://stackoverflow.com/questions/12592472/how-to-highlight-a-current-menu-item-in-angularjs
	$scope.getClass = function(page) {
		return $location.path() == '/Page/'+page ? 'active' : ''
	}
});

app.controller('keosu-rssController', function ($rootScope, $scope)
{
	$scope.init = function(params) {
        $scope.infiniteList = false;
        $rootScope.previousButton = false;
        $scope.param = params;
        $scope.isList = true;
        $scope.list = [];
        $scope.currentlist = [];
        $scope.page = 0;
        $scope.max = parseInt($(document).height()) - parseInt($(window).height());
        google.load('feeds', '1', {"callback": $scope.displayRss});
	}

    $scope.buildPage = function() {
        if ($scope.infiniteList == false)
            $scope.currentlist = [];
        console.log("update page");
        var offset = $scope.page * $scope.param.gadgetParam.articlesPerPage;
        for (var i = offset; i < offset + $scope.param.gadgetParam.articlesPerPage && i < $scope.list.length; i++)
            $scope.currentlist.push($scope.list[i]);
    }
    
    $rootScope.previous = function() {
        $rootScope.previousButton = false;
        $scope.isList = !$scope.isList;
    }

    $scope.open = function(elem) {
        $rootScope.previousButton = true;
        $scope.isList = !$scope.isList;
        $scope.title = elem.title;
        $scope.body = elem.body;
        $scope.path = elem.image;
        $scope.link = elem.link;
        $scope.hasImage = (elem.image != "");
        window.scrollTo(0, 0);
    }

    $scope.next = function() {      
        if ($scope.page < $scope.last)
            $scope.page += 1;
        $scope.buildPage();
    }

    $scope.prev = function() {
        if ($scope.page > 0)
            $scope.page -= 1;
        $scope.buildPage();
    }

    $scope.displayRss = function() {
        $scope.feed = new google.feeds.Feed($scope.param.gadgetParam.url);
        $scope.feed.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
        $scope.feed.setNumEntries(50);
      	$scope.feed.load(function(result){
        if (!result.error){
            for(var i = 0; i < result.feed.entries.length; i++) {
                var image = "";
                try {
                    image = result.feed.entries[i].xmlNode.getElementsByTagName("image")[0].innerHTML;
                }
                catch(err) {
                    try {
                        image = result.feed.entries[i].xmlNode.getElementsByTagName("enclosure")[0].getAttribute("url");
                    }
                    catch(err){
                        image = "";                        
                    }
                }
                $scope.list.push({"title": result.feed.entries[i].title,
                                  "body": result.feed.entries[i].content,
                                  "link": result.feed.entries[i].link,
                                  "image": image});
            }
            $scope.last = Math.ceil($scope.list.length / $scope.param.gadgetParam.articlesPerPage);
            $scope.buildPage();
            $scope.$apply();
        }
      });
    }

    $scope.setInfiniteList = function(){
        $scope.infiniteList = true;
    }

    $(window).on('scroll', function() {
        if ($scope.isList && !$scope.isLastPage && $scope.infiniteList){
            $scope.max = parseInt($(document).height()) - parseInt($(window).height()) - 1;
            if ($(window).scrollTop() >= $scope.max) {
                $scope.next();
                $scope.$apply();
            }
        }
    });
});
/* RSS Feed lemonde:  http://rss.lemonde.fr/c/205/f/3050/index.rss */app.directive('keosuComments', function(){
	return {
		restrict : 'E',
		scope : {
			objectId: '=objectId',
			objectName: '=objectName',
			enableComments: '=enableComments'
		},
		templateUrl : 'plugins/keosu-comments/templates/default.html',
		controller : ['$scope','$http', function ($scope, $http) {
		
			$scope.$watch('objectId', function() {
				$scope.myinit();
        	});
			
			$scope.myinit = function() {
				$http.get('data/globalParam.json').success(function(data){
					$scope.host = data.host;
					$scope.commentListAction();
				});
			}

			$scope.commentListAction = function() {
				if ($scope.objectId) {
					$http.get($scope.host+'service/gadget/comment/'+$scope.objectName+'/'+$scope.objectId).success(function(data){
						$scope.comments = data.comments;
						$scope.connect = data.connect;
					});
				}
			};

			$scope.commentAddAction = function() {
				var data = "message="+$scope.messageComment;
				$scope.messageComment = "";
				if (data != "message=") {//check if the commentaire is not empty
					$http.post($scope.host+'service/gadget/comment/'+$scope.objectName+'/'+$scope.objectId,data).success(function(data){
						$scope.comments = data.comments;
						$scope.connect = data.connect;
					});
				};
			};
		}]
	};
});
/************************************************************************
	Keosu is an open source CMS for mobile app
	Copyright (C) 2014  Vincent Le Borgne

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ************************************************************************/
app.controller('keosu-articleController', function ($scope, $http, $sce, usSpinnerService, cacheManagerService) {

	$http.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";

	/////////////////////////
	// Init part
	/////////////////////////
	$scope.init = function(params){
		$scope.param = params;
		$scope.articleInit();
	};
	
	/////////////////////////
	// Article part
	/////////////////////////
	$scope.articleInit = function() {
        if ($scope.param.gadgetParam.offline == true) {
            $http.get('data/article'+$scope.param.gadgetParam['article-id']+'.json').success(function(data) {
                $scope.article = data;
                $scope.article.content = $sce.trustAsHtml(data.content);
            });
        } else {
            usSpinnerService.spin('spinner'); // While loading, there will be a spinner
            cacheManagerService.get($scope.param.host+ 'service/gadget/article/' + $scope.param.gadgetId + '/json').success(function(data) {
                usSpinnerService.stop('spinner');
                $scope.article = data;
                $scope.article.content = $sce.trustAsHtml(data.content);
            });
        }
	};
	
});
